#include <amxmodx>
#include <engine>
#include <cstrike>
#include <hamsandwich>

#define PLUGIN "Gorro Natal"
#define VERSION "1.0"
#define AUTHOR "Wilian M. | xPaw"

#if defined client_disconnected
	#define client_disconnect client_disconnected
#endif

new const xHatModels[CsTeams][] ={ "", "models/gorro_tr.mdl", "models/gorro_ct.mdl", "" }

new g_iHats[33]

public plugin_init()
{
	register_plugin(PLUGIN, VERSION, AUTHOR)
	
	register_event("TeamInfo", "EventTeamInfo", "a")
	RegisterHam(Ham_Spawn, "player", "xHamSpawn", 1)
}

public plugin_precache()
{
	precache_model(xHatModels[CS_TEAM_T])
	precache_model(xHatModels[CS_TEAM_CT])
}

public client_disconnected(id)
{
	if(is_valid_ent(g_iHats[id]))
		remove_entity(g_iHats[id])
}
	

public xHamSpawn(id)
{
	if(is_user_alive(id))
	{
		new iEntity = g_iHats[id]
		
		if(!is_valid_ent(iEntity))
		{
			if(!(iEntity = g_iHats[id] = create_entity("info_target")))
				return;
			
			new CsTeams:iTeam = cs_get_user_team(id)
			
			if(iTeam != CS_TEAM_T && iTeam != CS_TEAM_CT)
				iTeam = CS_TEAM_T
			
			entity_set_model(iEntity, xHatModels[iTeam])
			entity_set_int(iEntity, EV_INT_movetype, MOVETYPE_FOLLOW)
			entity_set_edict(iEntity, EV_ENT_aiment, id)
		}
	}
}

public EventTeamInfo()
{
	new id = read_data(1), iEntity = g_iHats[id]
	
	if(!is_valid_ent(iEntity))
	{
		if(iEntity > 0)
			g_iHats[id] = 0;
		
		return;
	}
	
	new szTeam[2]
	read_data(2, szTeam, 1)
	
	if(szTeam[0] == 'C')
		entity_set_model( iEntity, xHatModels[CS_TEAM_CT])
	else
		entity_set_model( iEntity, xHatModels[CS_TEAM_T])
}
